/*
 * Copyright (c) 2012, Noel Lemouel
 * All rights reserved.
 */

#include "sysutil.h"
#include <string.h>

#include "font_8x8.c"

#define BGP 0xff47 /* BG Palette Data */
#define OBP0 0xff48 /* Object Palette 0 Data */
#define OBP1 0xff49 /* Object Palette 1 Data */

void main()
{
   unsigned int i, j;
   unsigned char* _p8;

   lcd_di();

   /* clear bg_map */
   memset((void *)0x9800, 0x00, 0xc00);

   /* palettes */
   *(volatile unsigned char*)BGP = 0xe4;
   *(volatile unsigned char*)OBP0 = 0xe4;
   *(volatile unsigned char*)OBP1 = 0xe4;

   _p8 = (unsigned char*)0x8000;

   j = 0;
   for(i=0; i<4096; i+=2)
   {
      _p8[i] = fontdata_8x8[j];
      _p8[i+1] = fontdata_8x8[j++];
   }

   lcd_en();

   printf("hello from gbz80\n\n");
/*
   printf("%s=0x%02x\n", "BGP", *(volatile unsigned char*)BGP);
   printf("%s=%%%08b\n", "BGP", *(volatile unsigned char*)BGP);
*/
   __asm
      halt
   __endasm;
}

