/*
 * Copyright (c) 2012, Noel Lemouel
 * All rights reserved.
 */

#include "sysutil.h"

static unsigned int x_pos = 0;
static unsigned int y_pos = 0;

void lcd_en(void)
{
   __asm
      ld hl,#0xff40  ; LCD Control
      ld a,(hl)
      or #0x80       ; (run / bit7=1)
      ld (hl),a
      ; ei
   __endasm;
}

void lcd_di(void)
{
   __asm
      ; di
      ; vblank period starts after line 144 is drawn (LY >= 144)
      _0:
      ld a,(#0xff44) ; LCDC Y-Coordinate
      cp #0x91       ; 145
      jr nz,_0
      ld hl,#0xff40  ; LCD Control
      ld a,(hl)
      and #0x7f      ; (stopped / bit7=0)
      ld (hl),a
      ; ei
   __endasm;
}

void putchar(char c)
{
   switch(c)
   {
      case '\n':
         x_pos=0;
         y_pos+=1;
         break;
      case '\r':
         x_pos=0;
         break;
      default:
         *(volatile unsigned char*)(0x9800 + (y_pos << 5) + x_pos) = c;
         x_pos++;
         if(x_pos == 20) x_pos=0, y_pos++;
         break;
   }

   if(y_pos == 18) x_pos=0, y_pos = 0;
}

void printf (const char *fmt, ...)
{
   char buf[64];
   char *s = buf;

   va_list args;

   va_start (args, fmt);

   vsprintf(buf, fmt, args);

   va_end (args);

   lcd_di();

   while(*s) putchar(*s++);

   lcd_en();
}

